/*
 * Licensed to Elastic Search and Shay Banon under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. Elastic Search licenses this
 * file to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.elasticsearch.transport.netty;

import org.elasticsearch.common.logging.ESLogger;
import org.elasticsearch.common.netty.logging.AbstractInternalLogger;

/**
 * @author kimchy (shay.banon)
 */
public class NettyInternalESLogger extends AbstractInternalLogger {

    private final ESLogger logger;

    public NettyInternalESLogger(ESLogger logger) {
        this.logger = logger;
    }

    @Override public boolean isDebugEnabled() {
        return logger.isDebugEnabled();
    }

    @Override public boolean isInfoEnabled() {
        return logger.isInfoEnabled();
    }

    @Override public boolean isWarnEnabled() {
        return logger.isWarnEnabled();
    }

    @Override public boolean isErrorEnabled() {
        return logger.isErrorEnabled();
    }

    @Override public void debug(String msg) {
        logger.debug(msg);
    }

    @Override public void debug(String msg, Throwable cause) {
        logger.debug(msg, cause);
    }

    @Override public void info(String msg) {
        logger.info(msg);
    }

    @Override public void info(String msg, Throwable cause) {
        logger.info(msg, cause);
    }

    @Override public void warn(String msg) {
        logger.warn(msg);
    }

    @Override public void warn(String msg, Throwable cause) {
        logger.warn(msg, cause);
    }

    @Override public void error(String msg) {
        logger.error(msg);
    }

    @Override public void error(String msg, Throwable cause) {
        logger.error(msg, cause);
    }
}
